#include <iostream>
#include <fstream>
#include "MCadena.h"
#include "MAsignatura.h"

using namespace std;
using namespace MCadena;

namespace MAsignatura  
{ 
  
  void LeerAsignaturaTeclado(TAsignatura &asignatura)
  {
       int i;
       
       cout << "Cdigo      : ";
       cin >> asignatura.codigo;
       cin.ignore(); // Ignoro el ENTER
       cout << "Nombre      : ";
       cin.getline(asignatura.nombre, MAXCAD+1,ENTER);
       cout << "Profesor    : ";
       cin.getline(asignatura.profesor, MAXCAD+1,ENTER);
       cout << "Grupo       : ";
       cin >> asignatura.grupo;
       cin.ignore(); // Ignoro el ENTER
       cout << "Num. Alumnos: ";
       cin >> asignatura.numAlumnos;
       cin.ignore(); // Ignoro el ENTER

       for(i=0;i<asignatura.numAlumnos;++i)
       {
           cout << "Alumno " << i << ":";
           cin.getline(asignatura.matriculados[i], MAXCAD+1,ENTER);
       }
  }
  
  void LeerAsignaturaFichero(ifstream &fich, TAsignatura &asignatura)
  {
       int i;
       
       fich >> asignatura.codigo;
       fich.ignore(); // Ignoro el ESPACIO
       fich >> asignatura.grupo;
       fich.ignore(); // Ignoro el ESPACIO
       fich.getline(asignatura.nombre, MAXCAD+1,SEP);
       fich.getline(asignatura.profesor, MAXCAD+1,SEP);
       fich >> asignatura.numAlumnos;
       fich.ignore(); // Ignoro el ESPACIO

       for(i=0;i<asignatura.numAlumnos-1;++i)
       {
           fich.getline(asignatura.matriculados[i], MAXCAD+1,SEP);
       }
       fich.getline(asignatura.matriculados[asignatura.numAlumnos-1], 
                    MAXCAD+1,ENTER);       
       // El ultimo va a parte porque termina en ENTER en vez de #

  }
  
  void EscribirAsignaturaPantalla(TAsignatura asignatura)
  {
       int i;
       
       cout << "Cdigo      : " << asignatura.codigo << endl;
       cout << "Nombre      : " << asignatura.nombre << endl;
       cout << "Grupo       : " << asignatura.grupo << endl;
       cout << "Profesor    : " << asignatura.profesor << endl;       
       cout << "Num. Alumnos: " << asignatura.numAlumnos << endl;

       for(i=0;i<asignatura.numAlumnos;++i)
       {
           cout << "\tAlumno " << i << ":" << asignatura.matriculados[i] << endl;
       }
  }
  
  void EscribirAsignaturaFichero(ofstream &fich, TAsignatura asignatura)
  {
       int i;
       
       fich << asignatura.codigo << SP
            << asignatura.grupo << SP
            << asignatura.nombre << SEP
            << asignatura.profesor << SEP
            << asignatura.numAlumnos << SP;
            
       for(i=0;i<asignatura.numAlumnos-1;++i)
       {
           fich << asignatura.matriculados[i] << SEP;
       }
       fich << asignatura.matriculados[asignatura.numAlumnos-1] << endl;
       // El ultimo va a parte porque termina en ENTER en vez de #

  }

}

